Cancel Flows
Start Cancel Flow Session
Initiate a new cancellation flow session for a customer.
POST
/
v1
/
cancel-flows
/
sessions
/
start
Start a cancel flow session
curl --request POST \
--url https://billing.example.com/v1/cancel-flows/sessions/start \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"customer_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"subscription_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
'import requests
url = "https://billing.example.com/v1/cancel-flows/sessions/start"
payload = {
"customer_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"subscription_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
customer_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
subscription_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'
})
};
fetch('https://billing.example.com/v1/cancel-flows/sessions/start', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"session_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"flow_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"steps": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"flow_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"step_order": 123,
"step_type": "survey",
"config": "<unknown>",
"created_at": "2023-11-07T05:31:56Z"
}
],
"first_step": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"flow_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"step_order": 123,
"step_type": "survey",
"config": "<unknown>",
"created_at": "2023-11-07T05:31:56Z"
}
}{
"error": {
"code": "BAD_REQUEST",
"message": "<string>"
}
}{
"error": {
"code": "BAD_REQUEST",
"message": "<string>"
}
}Body Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
customer_id | string | Yes | The unique identifier of the customer initiating cancellation. |
subscription_id | string | Yes | The subscription the customer wants to cancel. |
flow_id | string | No | Specific cancel flow to use. If omitted, the default flow is used. |
metadata | object | No | Arbitrary key-value pairs to attach to the session. |
Example Request
curl -X POST "https://api.recurso.io/v1/cancel-flows/sessions/start" \
-H "Authorization: Bearer rsk_live_9f8a7b6c5d4e3f2a1b0c" \
-H "Content-Type: application/json" \
-d '{
"customer_id": "cust_4kTg8LpR2mXn",
"subscription_id": "sub_7vWq3JsN9bYz",
"flow_id": "cflow_01h8x3kv7m2p"
}'
Response
{
"id": "csess_0a3f7c9e1b5d",
"object": "cancel_flow_session",
"status": "in_progress",
"flow_id": "cflow_01h8x3kv7m2p",
"customer_id": "cust_4kTg8LpR2mXn",
"subscription_id": "sub_7vWq3JsN9bYz",
"current_step_index": 0,
"current_step": {
"id": "cstep_01h8x3mw9n4q",
"type": "survey",
"title": "We're sorry to see you go",
"options": [
{ "key": "too_expensive", "label": "Too expensive" },
{ "key": "missing_features", "label": "Missing features" },
{ "key": "switched_competitor", "label": "Switched to a competitor" },
{ "key": "other", "label": "Other" }
]
},
"metadata": {},
"started_at": "2026-06-23T11:04:22Z",
"completed_at": null
}
Authorizations
Tenant API key obtained from POST /auth/register or POST /v1/developer/keys.
⌘I
Start a cancel flow session
